Include("vip/gamemode/func_regenerate_custom.nut");
Include("vip/gamemode/capture_point_filtering.nut");
Include("vip/gamemode/cane_pickup.nut");
Include("vip/gamemode/outline.nut");
Include("vip/gamemode/compass.nut");
Include("vip/gamemode/announcer.nut");
Include("vip/gamemode/overtime.nut");

Convars.SetValue("tf_bot_reevaluate_class_in_spawnroom", "0");

::FindVIP <- function(team)
{
    foreach (player in GetPlayers(team))
        if (IsVIP(player))
            return player;
    return null;
}

::IsVIP <- function(player)
{
    return GetCustomCharacter(player) instanceof VIPShared;
}

::firstRandomVIP <- RandomElement(GetPlayers(TF_TEAM_BLUE));

RunWithDelay(0.5, function()
{
    firstRandomVIP = null;
})

function SpawnBlueCaneAt(targetname)
{
    local ent = FindByName(null, targetname);
    if (canePickupScript)
        canePickupScript.DisablePickup();
    CanePickup(
        "models/vip_mobster/weapons/w_typewriter.mdl",
        ent.GetOrigin() - Vector(0, 0, 15),
        VIPMobster,
        TF_TEAM_BLUE);
}

OnGameEvent("clear_custom_character", function(player, params)
{
    if (IsVIP(player))
        FireCustomEvent("vip_gone", params);
});

OnGameEvent("player_spawn", function(player, args)
{
    if (GetUpcomingCustomCharacter(player) || GetCustomCharacter(player))
        return;
    local myClass = VIP_CLASS_CHARACTERS[player.GetPlayerClass()];
    if (player == firstRandomVIP)
        myClass = VIPMobster;
    if (myClass)
        ConvertToCustomCharacter(player, myClass);
});

OnGameEvent("post_inventory_application", function(player, args)
{
    printl("post_inventory_application "+GetUpcomingCustomCharacter(player))
    if (GetUpcomingCustomCharacter(player) || GetCustomCharacter(player))
        return;
    local myClass = VIP_CLASS_CHARACTERS[player.GetPlayerClass()];
    if (player == firstRandomVIP)
        myClass = VIPMobster;
    if (myClass)
        ConvertToCustomCharacter(player, myClass);
});

function ShowVIPAnnotation(player)
{
    local vip = FindVIP(player.GetTeam());
    if (!vip || vip == player)
        return;
    local myPos = vip.GetOrigin() + Vector(0, 0, 100);
    SendGlobalGameEvent("show_annotation",
    {
        worldPosX = myPos.x,
        worldPosY = myPos.y,
        worldPosZ = myPos.z,
        id = 121,
        text = "VIP",
        lifetime = 6,
        follow_entindex = vip.entindex(),
        visibilityBitfield = 1 << player.entindex()
    });
}
OnGameEvent("player_spawn_post", ShowVIPAnnotation);
OnGameEvent("player_teleported", ShowVIPAnnotation);